/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GuidJObjectValueTuple type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GuidJObjectValueTuple{}

// GuidJObjectValueTuple struct for GuidJObjectValueTuple
type GuidJObjectValueTuple struct {
	Item1 *string     `json:"item1,omitempty"`
	Item2 interface{} `json:"item2,omitempty"`
}

// NewGuidJObjectValueTuple instantiates a new GuidJObjectValueTuple object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGuidJObjectValueTuple() *GuidJObjectValueTuple {
	this := GuidJObjectValueTuple{}
	return &this
}

// NewGuidJObjectValueTupleWithDefaults instantiates a new GuidJObjectValueTuple object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGuidJObjectValueTupleWithDefaults() *GuidJObjectValueTuple {
	this := GuidJObjectValueTuple{}
	return &this
}

// GetItem1 returns the Item1 field value if set, zero value otherwise.
func (o *GuidJObjectValueTuple) GetItem1() string {
	if o == nil || IsNil(o.Item1) {
		var ret string
		return ret
	}
	return *o.Item1
}

// GetItem1Ok returns a tuple with the Item1 field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GuidJObjectValueTuple) GetItem1Ok() (*string, bool) {
	if o == nil || IsNil(o.Item1) {
		return nil, false
	}
	return o.Item1, true
}

// HasItem1 returns a boolean if a field has been set.
func (o *GuidJObjectValueTuple) HasItem1() bool {
	if o != nil && !IsNil(o.Item1) {
		return true
	}

	return false
}

// SetItem1 gets a reference to the given string and assigns it to the Item1 field.
func (o *GuidJObjectValueTuple) SetItem1(v string) {
	o.Item1 = &v
}

// GetItem2 returns the Item2 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GuidJObjectValueTuple) GetItem2() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Item2
}

// GetItem2Ok returns a tuple with the Item2 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GuidJObjectValueTuple) GetItem2Ok() (*interface{}, bool) {
	if o == nil || IsNil(o.Item2) {
		return nil, false
	}
	return &o.Item2, true
}

// HasItem2 returns a boolean if a field has been set.
func (o *GuidJObjectValueTuple) HasItem2() bool {
	if o != nil && !IsNil(o.Item2) {
		return true
	}

	return false
}

// SetItem2 gets a reference to the given interface{} and assigns it to the Item2 field.
func (o *GuidJObjectValueTuple) SetItem2(v interface{}) {
	o.Item2 = v
}

func (o GuidJObjectValueTuple) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GuidJObjectValueTuple) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Item1) {
		toSerialize["item1"] = o.Item1
	}
	if o.Item2 != nil {
		toSerialize["item2"] = o.Item2
	}
	return toSerialize, nil
}

type NullableGuidJObjectValueTuple struct {
	value *GuidJObjectValueTuple
	isSet bool
}

func (v NullableGuidJObjectValueTuple) Get() *GuidJObjectValueTuple {
	return v.value
}

func (v *NullableGuidJObjectValueTuple) Set(val *GuidJObjectValueTuple) {
	v.value = val
	v.isSet = true
}

func (v NullableGuidJObjectValueTuple) IsSet() bool {
	return v.isSet
}

func (v *NullableGuidJObjectValueTuple) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGuidJObjectValueTuple(val *GuidJObjectValueTuple) *NullableGuidJObjectValueTuple {
	return &NullableGuidJObjectValueTuple{value: val, isSet: true}
}

func (v NullableGuidJObjectValueTuple) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGuidJObjectValueTuple) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
